import _isArray from 'lodash.isarray'
import _has from 'lodash.has'

export function assignment_uuid (components) {
    if (!_isArray(components)) throw new Error('components is not array');

    return components.map(component => {
        let _component = component;

        if (!component.uuid) _component.uuid = generation_uuid();

        if (_has(_component, 'child_components')) {
            _component.child_components = assignment_uuid(_component.child_components);
        }
        return _component;
    });
}


export function generation_uuid() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = crypto.getRandomValues(new Uint8Array(1))[0]%16|0, v = c == 'x' ? r : (r&0x3|0x8);
        return v.toString(16);
    });
}

export default {assignment_uuid, generation_uuid}