/**
 * Find component in tree
 * @param components
 * @param cb_params_find
 * @param cb
 * @returns {*}
 */
export function find_component(components, cb_params_find, cb) {

    if (typeof cb_params_find === 'undefined') throw new Error('Criterion params search is required');


    if (Immutable.List.isList(components)) {

        return components.map(component => {


            if (cb_params_find(component)) return cb(component);


            if (component.has('child_components')) {
                return component.set('child_components', find_component(component.get('child_components'), cb_params_find, cb));
            }

            return component;
        });

    }

    if (cb_params_find(components)) return cb(components);


    return components;
}

export default find_component