import SelectField from 'material-ui/lib/select-field'
import TextField from 'material-ui/lib/text-field'
import MenuItem from 'material-ui/lib/menus/menu-item';


import ColHelper from './../../helpers/col'


class Select extends React.Component {
    constructor () {
        super();
        this.state = {
            id_selected: null
        }
    }
    render() {
        return (
            <div>
                <SelectField style={this.props.style}
                             hintText={this.props.hintText}
                             floatingLabelText={this.props.label}
                             floatingLabelStyle={this.props.labelStyle}
                             underlineFocusStyle={this.props.underlineFocusStyle}
                             underlineStyle={this.props.underlineStyle}
                             disabled={this.props.disabled}
                             value={this.state.id_selected}
                             fullWidth
                             onChange={this._onChange.bind(this)}>
                    {this.props.menuItems.map((item, index) => {
                        // TODO validate
                        return <MenuItem key={index} value={item.value} primaryText={item.text}/>
                    })}
                </SelectField>
                <TextField value={this.state.id_selected}  name={this.props.name} style={{display: 'none'}}/>
            </div>
        )
    }
    _onChange (e, index, value) {
        this.setState({
            id_selected: value
        })
    }
}

export default ColHelper(Select);