//const Checkbox         = React.createFactory(require('material-ui/lib/checkbox'));
//const RadioButton      = React.createFactory(require('material-ui/lib/radio-button'));
//const RadioButtonGroup = React.createFactory(require('material-ui/lib/radio-button-group'));
//const Toggle           = React.createFactory(require('material-ui/lib/toggle'))
//const Button           = React.createFactory(require('./button').default);
//const Grid             = React.createFactory(require('./grid').default);
//const Paper          = React.createFactory(require('./paper').default);
//const Form           = React.createFactory(require('./form').default);
//const Input          = React.createFactory(require('./form/input').default);
//const Select         = React.createFactory(require('./form/select').default);
//const Date           = React.createFactory(require('./form/date').default);
//const Table          = React.createFactory(require('./table').default);
//const FileInput      = React.createFactory(require('./form/file_input').default);
//const Block          = React.createFactory(require('./block/index.js').default);
//const RefreshBlock   = React.createFactory(require('./refresh_block').default);
var count_components = 0;

import Checkbox from 'material-ui/lib/checkbox'
import RadioButton from 'material-ui/lib/radio-button'
import RadioButtonGroup from 'material-ui/lib/radio-button-group'
import Toggle from 'material-ui/lib/toggle'
import Button from './button'
import Grid from './grid'
import Paper from './paper'
import Form from './form'
import Input from './form/input'
import Select from './form/select'
import Date from './form/date'
import Table from './table'
import FileInput from './form/file_input'
import Block from './block'
import RefreshBlock from './refresh_block'



class Factory {


    button(props) {
        return React.createElement(Button, {
            key      : props.uuid,
            label    : props.label,
            primary  : props.primary,
            secondary: props.secondary,
            floating : props.floating,
            raised   : props.raised,
            flat     : props.flat,
            mini     : props.mini,
            cols     : props.cols || 12,
            style    : props.style,
            disabled : props.disabled,
            iconName : props.icon_name,
            iconStyle: props.icon_style,
            href     : props.href,
            type     : props.type || ''
        });
    }

    grid(props) {
        return React.createElement(Grid, {
            key       : props.uuid,
            cols      : props.cols,
            cellHeight: props.cellHeight,
            padding   : props.padding,
            style     : props.style
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : []);
    }

    paper(props) {
        return React.createElement(Paper, {
            key   : props.uuid,
            zDepth: props.zDepth,
            style : props.style,
            cols  : props.cols || 12
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : []);
    }

    form(props) {
        return React.createElement(Form, {
            key             : props.uuid,
            cols            : props.cols || 12,
            to              : props.to,
            method          : props.method,
            redirect_to     : props.redirect_to,
            destination     : props.destination,
            crearAfterSubmit: props.clear_after_submit
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : [])

    }

    input(props) {
        return React.createElement(Input, {
            key                   : props.uuid,
            label                 : props.label,
            labelStyle            : props.label_style,
            defaultValue          : props.default_value,
            hintText              : props.hint_text,
            hintStyle             : props.hint_style,
            underlineDisabledStyle: props.underline_disabled_style,
            underlineStyle        : props.underline_style,
            value                 : props.value,
            underlineFocusStyle   : props.underline_focus_style,
            errorText             : props.error_text,
            errorStyle            : props.error_style,
            multiLine             : props.multi_line,
            disabled              : props.disabled,
            type                  : props.type,
            cols                  : props.cols || 12,
            name                  : props.name
        });
    }

    select(props) {
        return React.createElement(Select, {
            key                : count_components,
            menuItems          : props.items,
            hintText           : props.hint_text,
            label              : props.label,
            cols               : props.cols || 12,
            name               : props.name,
            labelStyle         : props.label_style,
            underlineFocusStyle: props.underline_focus_style,
            underlineStyle     : props.underline_style,
            disabled           : props.disabled || false
        });
    }

    date(props) {
        return React.createElement(Date, {
            key     : props.uuid,
            hintText: props.hint_text,
            locale: props.locale
        });
    }

    text(props) {
        return React.createElement(props.tag || 'span', {
            key  : props.uuid,
            style: props.style
        }, props.text);
    }

    checkbox(props) {
        return React.createElement(Checkbox, {
            name          : props.name,
            value         : props.value,
            label         : props.label,
            defaultChecked: props.default_checked || false,
            disabled      : props.disabled || false,
            style         : props.style,
            labelPosition : props.label_position,
            labelStyle    : props.label_style,
            key           : props.uuid
        });
    }

    radio_button_group(props) {
        return React.createElement(RadioButtonGroup, {
            name           : props.name,
            defaultSelected: props.default_selected,
            labelPosition  : props.label_position,
            style          : props.style,
            key            : props.uuid
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : []);
    }

    radio_button(props) {
        return React.createElement(RadioButton, {
            key  : props.uuid,
            label: props.label,
            value: props.value
        });
    }

    table(props) {
        return React.createElement(Table, {
            key : count_components,
            head: props.head,
            data: props.data
        })
    }


    file_input(props) {
        return React.createElement(FileInput, {
            key : props.uuid,
            cols: props.cols || 12,
            hintText: props.hint_text,
            buttonText: props.button_text || 'upload'
        });
    }

    block(props) {
        return React.createElement(Block, {
            key: count_components,
            id : props.id
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : []);

    }

    refresh_block(props) {
        return React.createElement(RefreshBlock, {
            key     : props.uuid,
            id      : props.uuid,
            to      : props.to,
            interval: props.interval
        }, props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : [])
    }

    html(props) {
        return React.createElement(props.tag, Object.assign(props.attributes || {}, {
            key: count_components
        }), props.child_components ? props.child_components.map(component => Factory.createComponent(component.component_type, component)) : props.text)
    }
}

Factory.createComponent = function (displayNameComponent:string, props:object) {
    var component;

    if (Factory.prototype[displayNameComponent] === undefined) {
        // TODO exeption
        throw new Error('unknown component');
    }

    component = new Factory.prototype[displayNameComponent](props);
    count_components++;

    // TODO error message;

    return component;

};

export default function (component) {
    if (typeof component.component_type !== 'undefined') {
        return Factory.createComponent(component.component_type, component);
    }
    return [];
}