import _has from 'lodash.has'
import Connect from 'react-redux/lib/components/connect'
import GridList from 'material-ui/lib/grid-list/grid-list'

import FactoryComponents from 'views/components/index'

import ContentActions from 'actions/content'
import RequestActions from 'actions/request'

import _isEqual from 'lodash.isequal'



class DynamicPage extends React.Component {

    componentWillReceiveProps (nextProps) {


        const PREV_MENU           = this.props.menu,
              PREV_LOCATION_PATH  = this.props.location.pathname,
              PREV_LOCATION_QUERY = this.props.location.query;


        const MENU           = nextProps.menu,
              LOCATION_PATH  = nextProps.location.pathname,
              LOCATION_QUERY = nextProps.location.query;



        if (!_isEqual(PREV_MENU, MENU)) {

            const SEARCHED_ITEM_MENU = this.searchActiveMenuItem(MENU);


            if (SEARCHED_ITEM_MENU !== -1) {

                this.props.dispatch(ContentActions.fetch_content(SEARCHED_ITEM_MENU.route));

            } else {

                this.props.dispatch(ContentActions.fetch_content(LOCATION_PATH, LOCATION_QUERY));

            }

        } else if (PREV_LOCATION_PATH !== LOCATION_PATH) {

            this.props.dispatch(RequestActions.abortRequests('content'));
            this.props.dispatch(ContentActions.fetch_content(LOCATION_PATH, LOCATION_QUERY));

        }


    }

    searchActiveMenuItem(items) {

        for (var i = items.length - 1; i >= 0; i--) {

            if (_has(items[i], 'route') && this.context.history.isActive(items[i].route, {}, true)) {

                return items[i];
            }

        }

        return -1;
    }

    render() {
        return (
            <div >{this.props.content.map((component) => {
                        return FactoryComponents(component)
            })}</div>

        )
    }
}
DynamicPage.contextTypes = {
    history: React.PropTypes.object
};

export default Connect(state => ({
    content: state.content.get('components'),
    menu   : state.menu.get('items')
}))(DynamicPage)